require "import"
require('io')
import "android.media.*"
import "java.io.File"
import "android.os.*"
import "android.content.*"
import "java.nio.file.Files"
import "java.nio.file.Paths"
import "android.net.*"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.view.View"
import "com.androlua.*"
import "java.net.*"
import "java.io.*"
import "android.media.ToneGenerator"
import "android.media.AudioManager"
import "android.os.VibrationEffect"
import "android.os.Vibrator"
import "android.content.Intent"
context = activity or service
vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(60)

function string.starts(String,Start)
   return string.sub(String,1,string.len(Start))==Start
end

function replace_at_end(str, substr, replacement)
    -- Check if the string ends with the specified substring
    if str:sub(-#substr) == substr then
        -- If it does, replace it with the replacement string
        return str:sub(1, -#substr - 1) .. replacement
    else
        -- If it doesn't, return the original string
        return str
    end
end

-- Function to read API key from 'api_key.txt' file using Lua's file functions
local filePath = "/storage/emulated/0/api_key.txt"
local file = io.open(filePath, "r")  -- Attempt to open the file in read mode
function readApiKey()

    if not file then
        -- File not found, attempt to create it with clipboard text
			local clipboardService = this.getSystemService(Context.CLIPBOARD_SERVICE)
        local clip = clipboardService.getPrimaryClip()
        local text = ""

        if clip and clip.getItemCount() > 0 then
            local item = clip.getItemAt(0)
            local clipText = item.getText()
            if clipText then
                text = clipText:match("^%s*(.-)%s*$")  -- Trim whitespace
            end
        end

        if text ~= "" and string.starts(text, "gsk") then
            -- Write the clipboard text to 'api_key.txt'
            local newFile = io.open(filePath, "w")
            if newFile then
                newFile:write(text)
                newFile:close()

                return text
            end
        else
            -- Clipboard is empty, instruct the user to obtain an API key
            print("cheia nu este prezentă sau este copiată greșit. Intrați pe groq.com, creați un cont și copiați cheia din secțiunea developers -< free API Key, apoi copiați-o în clipboard.")
            return nil
        end
    else
        -- File exists, read the API key
        local api_key = file:read("*a"):match("^%s*(.-)%s*$")  -- Read and trim whitespace
        file:close()  -- Close the file after reading

        if api_key == "" then
            -- File is empty, instruct the user to obtain an API key
            print("cheia nu este prezentă. Intrați pe groq.com, creați un cont și copiați cheia din secțiunea developers -< free API Key, apoi copiați-o în clipboard.")
            return nil
        else
            return api_key
        end
    end
end

-- Set the API key by reading from file
api_key = readApiKey()

-- Proceed only if api_key is successfully retrieved
if not api_key then
    -- Optionally, you can stop the script or handle the missing API key appropriately
    -- For example, show a toast message
    
    return
end

-- Function to initialize MediaRecorder
function setupMediaRecorder()
    local recorder = MediaRecorder()
    recorder.setAudioSource(MediaRecorder.AudioSource.MIC)
    recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
    recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
    recorder.setAudioEncodingBitRate(32000)
    recorder.setAudioSamplingRate(16000)
    recorder.setAudioChannels(1)
    recorder.setOutputFile("/sdcard/directDictation.mp3")
    recorder.prepare()
    return recorder
end

-- Function to start recording
function startRecording()
    mr = setupMediaRecorder()
 
    mr.start()
end

-- Function to stop recording and release MediaRecorder
function stopRecording()
    if mr then
        mr.stop()
        mr.release()
        mr = nil
    end
end



-- Function to play a tone
function PlayTone(tone, time)
    gen = ToneGenerator(AudioManager.STREAM_ACCESSIBILITY, 70)
    gen.startTone(tone, time) 
    task(222, function()
        gen.release()
    end)
end

-- Function to handle API request with file data
function throwData(fields)
    local boundary = "boundary"
    local conn = URL("https://api.groq.com/openai/v1/audio/transcriptions").openConnection()
    conn.setRequestMethod("POST")
    conn.setDoOutput(true)
    conn.setRequestProperty("Content-Type", "multipart/form-data; boundary=" .. boundary)
    conn.setRequestProperty("authorization", "bearer " .. api_key)
    
    local out = DataOutputStream(conn.getOutputStream())
    for field, value in pairs(fields) do
        if type(value) == "table" and value.filePath then
            local file = File(value.filePath)
            
            local fileContent = Files.readAllBytes(file.toPath())  -- Java method to read file 

            out.writeBytes("--" .. boundary .. "\r\n")
            out.writeBytes("Content-Disposition: form-data; name=\"" .. field .. "\"; filename=\"" .. file.getName() .. "\"\r\n")
            out.writeBytes("Content-Type: application/octet-stream\r\n\r\n")
            out.write(fileContent)
            out.writeBytes("\r\n")
        else
            out.writeBytes("--" .. boundary .. "\r\n")
            out.writeBytes("Content-Disposition: form-data; name=\"" .. field .. "\"\r\n\r\n")
            out.writeBytes(tostring(value) .. "\r\n")
        end
    end
    out.writeBytes("--" .. boundary .. "--\r\n")
    out.close()

    local reader = BufferedReader(InputStreamReader(conn.getInputStream()))
    local response = reader.readLine()
    reader.close()
    return response
end

-- Main function to handle recording and transcription
function main()
    local fields = {
        file = {filePath = "/sdcard/directDictation.mp3"},
        response_format = "text",
        model = "whisper-large-v3",
        language = "ro"
    }
    
    if mr then
        PlayTone(36, 333)
        stopRecording()
        local text = throwData(fields)

        if text then

text=replace_at_end(text, "Să vă mulțumim pentru vizionare!", "")
text=replace_at_end(text, "Să vă mulțumim pentru vizionare.", "")
text=replace_at_end(text, "Bine ati venit!", "")
text=replace_at_end(text, "Giesho", "Jieshuo")
text=replace_at_end(text, "Giosho", "Jieshuo")
text=replace_at_end(text, "Giesho", "Jieshuo")
text=replace_at_end(text, "GSO", "Jieshuo")
text=replace_at_end(text, "Giesu", "Jieshuo")
text=replace_at_end(text, "Gesu", "Jieshuo")
text=replace_at_end(text, "G.E. Show", "Jieshuo")
text=replace_at_end(text, " Dictare directă plus.", "")
text=replace_at_end(text, " Dictare directă plus", "")
text=replace_at_end(text, " Dictarea directă plus.", "")
text=replace_at_end(text, " Dictarea directă plus", "")
text=replace_at_end(text, " Dictare directă plus", "")
text=replace_at_end(text, " Dictare directa plus.", "")
text=replace_at_end(text, "Dictare Directă Plus", "")
text=replace_at_end(text, " Dictare directa plus", "")

service.setText(service.getText(node)..text)
            service.speak(text)
        else
this.speak("Eroare! Rostiți din nou..")
        end
    else
        PlayTone(69, 65)
        startRecording()
    end
end

-- Execute main function to start the process
main()


return true